%global sum Python interface to sendmail milter API
%global __provides_exclude_from ^(%{python2_sitearch})/.*\\.so$
%bcond_with python2
%global python2 python27

Summary: %{sum}
Name: python-pymilter
Version: 1.0.5
Release:    2%{?dist}
Url:    https://github.com/sdgathman/pymilter
Source0: https://github.com/sdgathman/pymilter/archive/pymilter-%{version}.tar.gz
Source1: tmpfiles-python-pymilter.conf
Patch0: pymilter-check.patch
License: GPLv2+
Group: Development/Libraries
BuildRequires: python%{python3_pkgversion}-devel, sendmail-devel >= 8.13
BuildRequires:  gcc
BuildRequires:  python%{python3_pkgversion}-bsddb3

%global _description\
This is a python extension module to enable python scripts to\
attach to sendmail's libmilter functionality.  Additional python\
modules provide for navigating and modifying MIME parts, sending\
DSNs, and doing CBV.

%description %_description


%package -n python%{python3_pkgversion}-pymilter
Summary: %{sum}
Requires: python%{python3_pkgversion}-py3dns
Requires: %{name}-common = %{version}-%{release}

%description -n python%{python3_pkgversion}-pymilter %_description

%package common
Summary: Common files and directories for python milters
BuildArch: noarch

%description common
Common files and directories used for python milters

%package selinux
Summary: SELinux policy module for pymilter
Group: System Environment/Base
Requires: policycoreutils, selinux-policy-targeted
Requires: %{name}-common = %{version}-%{release}
BuildArch: noarch
BuildRequires: policycoreutils, checkpolicy, selinux-policy-devel
BuildRequires: policycoreutils-python-utils

%description selinux
Give sendmail_t additional access to stream sockets used to communicate
with milters.

%prep
%setup -q -n pymilter-pymilter-%{version}
%patch0 -p1 -b .check
cp -p template.py milter-template.py


%build
%py3_build
checkmodule -m -M -o pymilter.mod pymilter.te
semodule_package -o pymilter.pp -m pymilter.mod

%install
%py3_install

mkdir -p %{buildroot}/run/milter
mkdir -p %{buildroot}%{_localstatedir}/log/milter
mkdir -p %{buildroot}%{_libexecdir}/milter
mkdir -p %{buildroot}%{_prefix}/lib/tmpfiles.d
install -m 0644 %{SOURCE1} %{buildroot}%{_prefix}/lib/tmpfiles.d/%{name}.conf

mkdir -p %{buildroot}%{_datadir}/selinux/targeted
cp -p pymilter.pp %{buildroot}%{_datadir}/selinux/targeted

%check
py3path=$(ls -d build/lib.linux-*-3*)
PYTHONPATH=${py3path}:. python3 test.py


%files -n python%{python3_pkgversion}-pymilter
%license COPYING
%doc README.md ChangeLog NEWS TODO CREDITS sample.py milter-template.py
%{python3_sitearch}/*

%files common
%dir %{_libexecdir}/milter
%{_prefix}/lib/tmpfiles.d/%{name}.conf
%dir %attr(0755,mail,mail) %{_localstatedir}/log/milter
%dir %attr(0755,mail,mail) /run/milter

%files selinux
%doc pymilter.te
%{_datadir}/selinux/targeted/*

%post selinux
%{_sbindir}/semodule -s targeted -i %{_datadir}/selinux/targeted/pymilter.pp \
        &>/dev/null || :

%postun selinux
if [ $1 -eq 0 ] ; then
%{_sbindir}/semodule -s targeted -r pymilter &> /dev/null || :
fi

%changelog
* Wed Jun 11 2025 bbrucezhang <bbrucezhang@tencent.com> - 1.0.5-2
- Rebuilt for loongarch64

* Fri Jun 28 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.0.5-1
- initial build
